package ejem07;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.Date;
import java.util.Vector;

public class SistemaSolar extends Applet implements Runnable,MouseListener {

	private long dT=100;
	private Thread thr=null;
	private Image back;
	private Graphics g,bg;
	private int w,h;
	private boolean ponOrbita=false;

	Date d;
	double seg=Math.PI/30,arg;
	double min ;
	double hour;
	Vector colores,/*deltaAngulo,anguloAct,*/radioPlaneta,radioOrbita;
	static final int N_PLANETAS = 5;
	Double anguloAct[]= new Double[5];
	Double deltaAngulo[] = new Double[5];
	Image img;
		
	
	
	public void init(){
		colores = new Vector(N_PLANETAS);
		//deltaAngulo = new Vector(N_PLANETAS);
		//anguloAct = new Vector(N_PLANETAS);
		radioPlaneta = new Vector(N_PLANETAS);
		radioOrbita = new Vector(N_PLANETAS);
		setBackground(Color.black);
		colores.addElement(Color.white);
		colores.addElement(Color.blue);
		colores.addElement(Color.green);
		colores.addElement(Color.red);
		colores.addElement(Color.yellow);

		
		deltaAngulo[0]=new Double(Math.PI/(double)10.0);
		deltaAngulo[1]=new Double(Math.PI/(double)30.0);
		deltaAngulo[2]=new Double(Math.PI/(double)15.0);
		deltaAngulo[3]=new Double(Math.PI/(double)35.0);
		deltaAngulo[4]=new Double(Math.PI/(double)40.0);

		
		anguloAct[0]=new Double(Math.PI/(double)1.0);
		anguloAct[1]=new Double(Math.PI/(double)30.0);
		anguloAct[2]=new Double(Math.PI/(double)15.0);
		anguloAct[3]=new Double(Math.PI/(double)1.0);
		anguloAct[4]=new Double(Math.PI/(double)40.0);

		radioPlaneta.addElement(new Integer(10));
		radioPlaneta.addElement(new Integer(15));
		radioPlaneta.addElement(new Integer(25));
		radioPlaneta.addElement(new Integer(10));
		radioPlaneta.addElement(new Integer(40));

		radioOrbita.addElement(new Integer(90));
		radioOrbita.addElement(new Integer(120));
		radioOrbita.addElement(new Integer(180));
		radioOrbita.addElement(new Integer(300));
		radioOrbita.addElement(new Integer(400));
		addMouseListener(this);
		
	}
	
	public void start() {
		w=getSize().width;
		h=getSize().height;
		back=createImage(w,h);
		bg=back.getGraphics();
		g=getGraphics();
		
		
		if (thr==null) { 
			thr=new Thread(this); 
			thr.start(); 
		}
		
	}

	public void stop() {
		if (thr!=null) { 
			thr.stop(); 
			thr=null; 
		}
	}

	public void parar()  {
		if (thr!=null) { 
			thr.suspend(); 
		}
	}

	public void continuar() {
		if (thr!=null) { 
			thr.resume(); 
		}
	}

	public void run() { 
		
		int w2=w/2,h2=h/2,RMax,R=5;
		double angulo,angulo2;
		
		if(w2>h2)
			RMax=w2;
		else
			RMax=h2;
			
		int conta=0,conta2=0;
		int nColor=1;
		int nPlaneta;
		
		Color color1=Color.red,color2=Color.yellow;
		boolean uno=true;
		
		while (true) {
		
			//Vector colores,deltaAngulo,anguloAct,radioPlaneta,radioOrbita;

			bg.setColor(Color.black);
			bg.fillRect(0,0,w,h);

			conta++;
			if(conta==4){
				conta2++;
				if(conta2>10){
					bg.setColor(Color.white);
					bg.setFont(new Font("TimesRoman",Font.BOLD,16));
					bg.drawString("Click me !!! Please. :-)",10,20);
				}
				if(conta2==20){
					conta2=0;
				}
				conta=0;
				if(uno){
					color1=Color.red;
					color2=Color.yellow;
				}
				else{
					color2=Color.red;
					color1=Color.yellow;
				}
				uno = !uno;
			}
			
			bg.setColor(color1);
			R=45;
			bg.fillOval(w2-R/2,h2-R/2,R,R);
			
			bg.setColor(color2);
			R=40;
			bg.fillOval(w2-R/2,h2-R/2,R,R);
			
			bg.setColor(color1);
			R=30;
			bg.fillOval(w2-R/2,h2-R/2,R,R);
			
			bg.setColor(color2);
			R=20;
			bg.fillOval(w2-R/2,h2-R/2,R,R);
			
			bg.setColor(color1);
			R=10;
			bg.fillOval(w2-R/2,h2-R/2,R,R);
			
			int x,y;
			for(nPlaneta=0;nPlaneta<N_PLANETAS;nPlaneta++){			
				bg.setColor((Color) colores.elementAt(nPlaneta));
				
				//orbita
				R=((Integer)radioOrbita.elementAt(nPlaneta)).intValue();
				
				if(ponOrbita)
					bg.drawOval(w2-R/2,h2-R/2,R,R);
				
				/*obtener coordenada*/
				angulo=anguloAct[nPlaneta].doubleValue();
				
				//System.out.println(angulo+","+nPlaneta);
				
				angulo2=deltaAngulo[nPlaneta].doubleValue();
				
				//System.out.println(angulo);
				angulo=angulo+angulo2;
				anguloAct[nPlaneta]= new Double(angulo);
				
				//anguloAct.insertElementAt(new Double(angulo),nPlaneta);
	
	
				x=(int)((R/2)*Math.cos(angulo));
				y=(int)((R/2)*Math.sin(angulo));
				/*radio de Planeta*/
				R=((Integer)radioPlaneta.elementAt(nPlaneta)).intValue();
				bg.fillOval(w2+(x-R/2),h2-(y+R/2),R,R);

				
			}
			
			g.drawImage(back,0,0,this);
		
			try { 
				thr.sleep(dT); 
			} catch (InterruptedException ie) { 
				// respaldar arg
				break; 
			}
		}
		
	}
	public void mouseClicked(MouseEvent e){
		ponOrbita=!ponOrbita;
	}
	public void mousePressed(MouseEvent e){
	}
	public void mouseReleased(MouseEvent e){
	}
	public void mouseEntered(MouseEvent e){
	}
	public void mouseExited(MouseEvent e){
	}

}
